package tankGame01;

import javax.swing.*;
import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Vector;

import static tankGame01.Constants.Direct.*;

public class MyPanel extends JPanel implements KeyListener {
    MyTank myTank;
    Vector<EnemyTank> tanks = new Vector<>();
    int initEnemyTanks = 4;
    public MyPanel() {
        myTank = new MyTank(100,100,UP);
        myTank.setStep(10);
        for (int i = 0; i < initEnemyTanks; i++) {
            tanks.add(new EnemyTank((100+(100*i)),0,DOWN));
        }
    }
    @Override
    public void keyTyped(KeyEvent e) {

    }

    @Override
    public void keyPressed(KeyEvent e) {
        if(e.getKeyCode() == KeyEvent.VK_DOWN) {
            // 键盘向下 y+1
            myTank.moveDown();
            myTank.setDirect(DOWN);
        } else if(e.getKeyCode() == KeyEvent.VK_UP) {
            myTank.moveUp();
            myTank.setDirect(UP);
        } else if(e.getKeyCode() == KeyEvent.VK_LEFT) {
            myTank.moveLeft();
            myTank.setDirect(LEFT);
        } else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
            myTank.moveRight();
            myTank.setDirect(RIGHT);
        }
        this.repaint();
    }

    @Override
    public void keyReleased(KeyEvent e) {

    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        // 填充矩形
        g.fillRect(0,0, Constants.Frame.FRAME_WIDTH,Constants.Frame.FRAME_HEIGHT);
        // 画出我方坦克
        drawTank(g,myTank);
        // 画出敌方坦克
        for (EnemyTank enemyTank : tanks) {
            drawTank(g,enemyTank);
        }
    }

    private void drawTank (Graphics g,Tank tank) {
        Color color = tank.getCamp() == Constants.Camp.MY ? Color.CYAN:Color.ORANGE;
        // 画坦克
        g.setColor(color);
        int x = tank.getX();
        int y = tank.getY();
        switch (tank.getDirect()) {
            // 向上
            case 1:
                g.fill3DRect(x,y,10,60,false);// 坦克左侧履带
                g.fill3DRect(x+30,y,10,60,false);// 坦克右侧履带
                g.fill3DRect(x+10,y+10,20,40,false); // 中间控制台
                g.fillOval(x+10,y+20,20,20);  // 画坦克的盖子
                g.drawLine(x+20,y+30,x+20,y);// 画机关枪（中间的线）
                break;
            // 向下
            case 2:
                g.fill3DRect(x,y,10,60,false);// 坦克左侧履带
                g.fill3DRect(x+30,y,10,60,false);// 坦克右侧履带
                g.fill3DRect(x+10,y+10,20,40,false); // 中间控制台
                g.fillOval(x+10,y+20,20,20);  // 画坦克的盖子
                g.drawLine(x+20,y+30,x+20,y+60);// 画机关枪（中间的线）
                break;
            // 向左
            case 3:
                g.fill3DRect(x,y,60,10,false);// 坦克上履带履带
                g.fill3DRect(x,y+30,60,10,false);// 坦克下侧履带
                g.fill3DRect(x+10,y+10,40,20,false); // 中间控制台
                g.fillOval(x+20,y+10,20,20);  // 画坦克的盖子
                g.drawLine(x+30,y+20,x,y+20);// 画机关枪（中间的线）
                break;
            // 向右
            case 4:
                g.fill3DRect(x,y,60,10,false);// 坦克上履带履带
                g.fill3DRect(x,y+30,60,10,false);// 坦克下侧履带
                g.fill3DRect(x+10,y+10,40,20,false); // 中间控制台
                g.fillOval(x+20,y+10,20,20);  // 画坦克的盖子
                g.drawLine(x+30,y+20,x+60,y+20);// 画机关枪（中间的线）
                break;
        }


    }

}
